package javax.lang.model.util;

import javax.lang.model.type.DeclaredType;
import javax.lang.model.type.WildcardType;
import javax.lang.model.type.ArrayType;
import javax.lang.model.type.NoType;
import javax.lang.model.type.NullType;
import javax.lang.model.type.TypeKind;
import javax.lang.model.element.TypeElement;
import javax.lang.model.type.PrimitiveType;
import java.util.List;
import javax.lang.model.type.ExecutableType;
import javax.lang.model.element.Element;
import javax.lang.model.type.TypeMirror;

public interface Types
{
    public abstract Element asElement(TypeMirror p0);
    
    public abstract boolean isSameType(TypeMirror p0, TypeMirror p1);
    
    public abstract boolean isSubtype(TypeMirror p0, TypeMirror p1);
    
    public abstract boolean isAssignable(TypeMirror p0, TypeMirror p1);
    
    public abstract boolean contains(TypeMirror p0, TypeMirror p1);
    
    public abstract boolean isSubsignature(ExecutableType p0, ExecutableType p1);
    
    public abstract List<? extends TypeMirror> directSupertypes(TypeMirror p0);
    
    public abstract TypeMirror erasure(TypeMirror p0);
    
    public abstract TypeElement boxedClass(PrimitiveType p0);
    
    public abstract PrimitiveType unboxedType(TypeMirror p0);
    
    public abstract TypeMirror capture(TypeMirror p0);
    
    public abstract PrimitiveType getPrimitiveType(TypeKind p0);
    
    public abstract NullType getNullType();
    
    public abstract NoType getNoType(TypeKind p0);
    
    public abstract ArrayType getArrayType(TypeMirror p0);
    
    public abstract WildcardType getWildcardType(TypeMirror p0, TypeMirror p1);
    
    public abstract DeclaredType getDeclaredType(TypeElement p0, TypeMirror... p1);
    
    public abstract DeclaredType getDeclaredType(DeclaredType p0, TypeElement p1, TypeMirror... p2);
    
    public abstract TypeMirror asMemberOf(DeclaredType p0, Element p1);
}
